︠fc2f531e-bdd5-4b28-8496-2538bdfea968i︠
%md
Here is some code for analyzing the questions raised in your first Sage homework.
︡74ebd41b-08f1-4fa1-8501-61bbcf0790dc︡{"done":true,"md":"Here is some code for analyzing the questions raised in your first Sage homework."}
︠e79abc9d-9fd2-48f3-9d3c-421913d43009s︠
#############################
# 1. Average number of cycles
#############################
# we will look at SymmetricGroup(n) for various values of n
nValues = [5,10, 20, 50, 100, 200, 1000]
nTrials = 500 #we will take 500 samples of random permutations for each n

for n in nValues:
    
    G = SymmetricGroup(n)
    total = 0 # sum of cycle lents 
    for _ in range(nTrials):
        t = G.random_element()
        tc = t.cycle_tuples()
        total += len(tc) #add to total
    avg = float(total/nTrials)  #compute average
    averageCycleLengths.append(avg) #store average in list
    # now print results
    print n, avg

︡8fa90416-5094-4d46-adf0-04b568f289ba︡{"stdout":"5"}︡{"stdout":" 1.256\n10"}︡{"stdout":" 1.892\n20"}︡{"stdout":" 2.562\n50"}︡{"stdout":" 3.358\n100"}︡{"stdout":" 4.362\n200"}︡{"stdout":" 5.07\n1000"}︡{"stdout":" 6.516\n"}︡{"done":true}︡
︠1d91cadf-45bf-43c2-a5f5-36924cde05de︠
# It looks vaguely logarithmic, as Sarah M. observed.
︡30f0a9a4-62bd-4b25-a82c-55518d71d528︡
︠384f5773-3b6e-431a-a9db-1ee7a9b66e63s︠
#############################
# 2. Probability of derangement
#############################

# A permutation is a derangement if it has no fixed points.  So we need a fixed point calculator function
def nFixedPts(perm,n):
    #it is understood that perm is an element of SymmetricGroup(n) 
    nFP=0 #this is the output which we will iterate
    for i in [1..n]:
        if perm(i)==i: 
            nFP += 1
    return nFP
    
# Now we do the same statistical analysis with the same values of n as in the previous problem
nValues = [5,10, 20, 50, 100, 200, 1000]
nTrials = 500 #we will take 500 samples of random permutations for each n

for n in nValues:
    G = SymmetricGroup(n)
    total = 0 # the number of derangements
    for _ in range(nTrials):
        t = G.random_element()
        if nFixedPts(t,n)==0: #a derangement!
            total += 1
    avg = float(total/nTrials)  #compute fraction of derangements
        
    # now print results
    print n, avg
︡34e42dc0-17d0-4c82-8d93-1973061203d2︡{"stdout":"5"}︡{"stdout":" 0.39\n10"}︡{"stdout":" 0.338\n20"}︡{"stdout":" 0.362\n50"}︡{"stdout":" 0.382\n100"}︡{"stdout":" 0.356\n200"}︡{"stdout":" 0.394\n1000"}︡{"stdout":" 0.37\n"}︡{"done":true}︡
︠267099e7-2875-4e91-9011-a3cef7aa5887︠
# Notice the surprising fact that the fraction of permutations that are derangements appears to be around 0.38 or so, independent of n!
︡501969d5-8655-4c84-822e-6ca79c23a12f︡
︠a6eb51fe-da55-4eeb-b223-60f954ee520as︠

#############################
# 3. average number of fixed points
#############################

#we already have the fixed point calculator function, so we can just apply it using virtually the same code.

nValues = [5,10, 20, 50, 100, 200, 1000]
nTrials = 500 #we will take 500 samples of random permutations for each n

for n in nValues:
    G = SymmetricGroup(n)
    total = 0 # the sum of number of fixed points
    for _ in range(nTrials):
        t = G.random_element()
        total += nFixedPts(t,n)
    avg = float(total/nTrials)  #compute average number of fixed points
        
    # now print results
    print n, avg
︡7b58e042-2131-42b6-9036-af6888c98b0b︡{"stdout":"5"}︡{"stdout":" 1.034\n10"}︡{"stdout":" 1.028\n20"}︡{"stdout":" 0.94\n50"}︡{"stdout":" 1.024\n100"}︡{"stdout":" 1.036\n200"}︡{"stdout":" 0.978\n1000"}︡{"stdout":" 0.926\n"}︡{"done":true}︡
︠e23d4c14-cdcd-4790-bd2f-18862fa928b9︠
# Once again, a surprising result:  the average number of fixed points seems to be 1, no matter what n is!









